/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using SeriousSIP.Client;
using SeriousSIP.Model;

namespace SeriousSIP.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IMessagesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Acknowledge the reception of an instant message from a sip peer.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the message received that needs to be acknowledged. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1MessagesMessageAckDelete (string id = null);

        /// <summary>
        /// Acknowledge the reception of an instant message from a sip peer.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the message received that needs to be acknowledged. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1MessagesMessageAckDeleteWithHttpInfo (string id = null);
        /// <summary>
        /// Send a new instant message to a sip peer.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1MessagesMessageSendPost (SendMessageParams body = null);

        /// <summary>
        /// Send a new instant message to a sip peer.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1MessagesMessageSendPostWithHttpInfo (SendMessageParams body = null);
        /// <summary>
        /// Retrieve the last 24h stats for instant messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1MessagesMessageStatisticsGet ();

        /// <summary>
        /// Retrieve the last 24h stats for instant messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1MessagesMessageStatisticsGetWithHttpInfo ();
        /// <summary>
        /// Subscribe to message server events to recieve webhook notifications on incoming and outgoing messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1MessagesSubscribePost (MessagesSubscribeParams body = null);

        /// <summary>
        /// Subscribe to message server events to recieve webhook notifications on incoming and outgoing messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1MessagesSubscribePostWithHttpInfo (MessagesSubscribeParams body = null);
        /// <summary>
        /// Send a new SMS to a mobile destination.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1MessagesTextSendPost (SendMessageParams body = null);

        /// <summary>
        /// Send a new SMS to a mobile destination.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1MessagesTextSendPostWithHttpInfo (SendMessageParams body = null);
        /// <summary>
        /// Retrieve the last 24 hours stats for text messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1MessagesTextStatisticsGet ();

        /// <summary>
        /// Retrieve the last 24 hours stats for text messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1MessagesTextStatisticsGetWithHttpInfo ();
        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1MessagesUnsubscribePut (MessagesUnsubscribeParams body = null);

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1MessagesUnsubscribePutWithHttpInfo (MessagesUnsubscribeParams body = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Acknowledge the reception of an instant message from a sip peer.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the message received that needs to be acknowledged. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesMessageAckDeleteAsync (string id = null);

        /// <summary>
        /// Acknowledge the reception of an instant message from a sip peer.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the message received that needs to be acknowledged. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesMessageAckDeleteAsyncWithHttpInfo (string id = null);
        /// <summary>
        /// Send a new instant message to a sip peer.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesMessageSendPostAsync (SendMessageParams body = null);

        /// <summary>
        /// Send a new instant message to a sip peer.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesMessageSendPostAsyncWithHttpInfo (SendMessageParams body = null);
        /// <summary>
        /// Retrieve the last 24h stats for instant messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesMessageStatisticsGetAsync ();

        /// <summary>
        /// Retrieve the last 24h stats for instant messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesMessageStatisticsGetAsyncWithHttpInfo ();
        /// <summary>
        /// Subscribe to message server events to recieve webhook notifications on incoming and outgoing messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesSubscribePostAsync (MessagesSubscribeParams body = null);

        /// <summary>
        /// Subscribe to message server events to recieve webhook notifications on incoming and outgoing messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesSubscribePostAsyncWithHttpInfo (MessagesSubscribeParams body = null);
        /// <summary>
        /// Send a new SMS to a mobile destination.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesTextSendPostAsync (SendMessageParams body = null);

        /// <summary>
        /// Send a new SMS to a mobile destination.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesTextSendPostAsyncWithHttpInfo (SendMessageParams body = null);
        /// <summary>
        /// Retrieve the last 24 hours stats for text messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesTextStatisticsGetAsync ();

        /// <summary>
        /// Retrieve the last 24 hours stats for text messages.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesTextStatisticsGetAsyncWithHttpInfo ();
        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesUnsubscribePutAsync (MessagesUnsubscribeParams body = null);

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesUnsubscribePutAsyncWithHttpInfo (MessagesUnsubscribeParams body = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class MessagesApi : IMessagesApi
    {
        private SeriousSIP.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="MessagesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public MessagesApi(String basePath)
        {
            this.Configuration = new SeriousSIP.Client.Configuration { BasePath = basePath };

            ExceptionFactory = SeriousSIP.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="MessagesApi"/> class
        /// </summary>
        /// <returns></returns>
        public MessagesApi()
        {
            this.Configuration = SeriousSIP.Client.Configuration.Default;

            ExceptionFactory = SeriousSIP.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="MessagesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public MessagesApi(SeriousSIP.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = SeriousSIP.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = SeriousSIP.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public SeriousSIP.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public SeriousSIP.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Acknowledge the reception of an instant message from a sip peer. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the message received that needs to be acknowledged. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1MessagesMessageAckDelete (string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1MessagesMessageAckDeleteWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Acknowledge the reception of an instant message from a sip peer. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the message received that needs to be acknowledged. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1MessagesMessageAckDeleteWithHttpInfo (string id = null)
        {

            var localVarPath = "/api/v1/messages/message/ack";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesMessageAckDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Acknowledge the reception of an instant message from a sip peer. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the message received that needs to be acknowledged. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesMessageAckDeleteAsync (string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1MessagesMessageAckDeleteAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Acknowledge the reception of an instant message from a sip peer. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the message received that needs to be acknowledged. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesMessageAckDeleteAsyncWithHttpInfo (string id = null)
        {

            var localVarPath = "/api/v1/messages/message/ack";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesMessageAckDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Send a new instant message to a sip peer. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1MessagesMessageSendPost (SendMessageParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1MessagesMessageSendPostWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Send a new instant message to a sip peer. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1MessagesMessageSendPostWithHttpInfo (SendMessageParams body = null)
        {

            var localVarPath = "/api/v1/messages/message/send";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesMessageSendPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Send a new instant message to a sip peer. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesMessageSendPostAsync (SendMessageParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1MessagesMessageSendPostAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Send a new instant message to a sip peer. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesMessageSendPostAsyncWithHttpInfo (SendMessageParams body = null)
        {

            var localVarPath = "/api/v1/messages/message/send";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesMessageSendPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Retrieve the last 24h stats for instant messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1MessagesMessageStatisticsGet ()
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1MessagesMessageStatisticsGetWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieve the last 24h stats for instant messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1MessagesMessageStatisticsGetWithHttpInfo ()
        {

            var localVarPath = "/api/v1/messages/message/statistics";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesMessageStatisticsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Retrieve the last 24h stats for instant messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesMessageStatisticsGetAsync ()
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1MessagesMessageStatisticsGetAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Retrieve the last 24h stats for instant messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesMessageStatisticsGetAsyncWithHttpInfo ()
        {

            var localVarPath = "/api/v1/messages/message/statistics";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesMessageStatisticsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Subscribe to message server events to recieve webhook notifications on incoming and outgoing messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1MessagesSubscribePost (MessagesSubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1MessagesSubscribePostWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Subscribe to message server events to recieve webhook notifications on incoming and outgoing messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1MessagesSubscribePostWithHttpInfo (MessagesSubscribeParams body = null)
        {

            var localVarPath = "/api/v1/messages/subscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesSubscribePost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Subscribe to message server events to recieve webhook notifications on incoming and outgoing messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesSubscribePostAsync (MessagesSubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1MessagesSubscribePostAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Subscribe to message server events to recieve webhook notifications on incoming and outgoing messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesSubscribePostAsyncWithHttpInfo (MessagesSubscribeParams body = null)
        {

            var localVarPath = "/api/v1/messages/subscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesSubscribePost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Send a new SMS to a mobile destination. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1MessagesTextSendPost (SendMessageParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1MessagesTextSendPostWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Send a new SMS to a mobile destination. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1MessagesTextSendPostWithHttpInfo (SendMessageParams body = null)
        {

            var localVarPath = "/api/v1/messages/text/send";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesTextSendPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Send a new SMS to a mobile destination. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesTextSendPostAsync (SendMessageParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1MessagesTextSendPostAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Send a new SMS to a mobile destination. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the SendMessageParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesTextSendPostAsyncWithHttpInfo (SendMessageParams body = null)
        {

            var localVarPath = "/api/v1/messages/text/send";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesTextSendPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Retrieve the last 24 hours stats for text messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1MessagesTextStatisticsGet ()
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1MessagesTextStatisticsGetWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieve the last 24 hours stats for text messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1MessagesTextStatisticsGetWithHttpInfo ()
        {

            var localVarPath = "/api/v1/messages/text/statistics";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesTextStatisticsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Retrieve the last 24 hours stats for text messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesTextStatisticsGetAsync ()
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1MessagesTextStatisticsGetAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Retrieve the last 24 hours stats for text messages. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesTextStatisticsGetAsyncWithHttpInfo ()
        {

            var localVarPath = "/api/v1/messages/text/statistics";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesTextStatisticsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1MessagesUnsubscribePut (MessagesUnsubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1MessagesUnsubscribePutWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1MessagesUnsubscribePutWithHttpInfo (MessagesUnsubscribeParams body = null)
        {

            var localVarPath = "/api/v1/messages/unsubscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesUnsubscribePut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1MessagesUnsubscribePutAsync (MessagesUnsubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1MessagesUnsubscribePutAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook calls for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the MessagesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1MessagesUnsubscribePutAsyncWithHttpInfo (MessagesUnsubscribeParams body = null)
        {

            var localVarPath = "/api/v1/messages/unsubscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1MessagesUnsubscribePut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

    }
}
